{$APPTYPE GUI}
{$R videoplayer.res}
Program VideoPlayer;
Uses
libavcodec,
libavformat,
libavutil,
libavutil_frame,
libavutil_mem,
libavutil_pixfmt,
libavutil_rational,
libavutil_samplefmt,
libavutil_channel_layout,
libswscale,
libswresample,
sysutils,
mmsystem,
windows,
disPlay;

function r2s(r:real):string;
var h,m,s,ss:longword;
begin
if r<0 then r:=0;
ss:=trunc(r*1000);
s:=ss div 1000;
ss:=ss mod 1000;
m:=s div 60;
s:=s mod 60;
h:=m div 60;
m:=m mod 60;
r2s:=i2s(m)+':'+i2s(s,2,'0')+'.'+i2s(ss div 100);
if h>0 then r2s:=i2s(h)+':'+i2s(m,2,'0')+':'+i2s(s,2,'0')+'.'+i2s(ss div 100);
end;

type VideoFRAME=record
       frame:pbitmap;
       time:real;
       next:pointer;
       end;
type PVideoFRAME=^VideoFRAME;

type AudioFRAME=record
       frame:pwavehdr;
       time:real;
       next:pointer;
       size:longword;
       end;
type PAudioFRAME=^AudioFRAME;

type SubtitleFRAME=record
       frame:pavsubtitle;
       time:real;
       next:pointer;
       prev:pointer;
       end;
type PSubtitleFRAME=^SubtitleFRAME;

var fdir:ansistring;

var fname:ansistring;

var avfmt:PAVFormatContext;
var avindex,vindex,aindex,sindex:longint;
const MAXINDEX=10;
var vindexa,aindexa,sindexa:array[0..MAXINDEX]of longint;
var vindexi,aindexi,sindexi:longint;
var vcodectx,acodectx,scodectx:PAVCodecContext;
var vcodec,acodec,scodec:PAVCodec;
var vframe,vframergb,aframe:PAVFrame;
var sframe:PAVSubtitle;
var vframefinish,aframefinish,sframefinish:longint;
var packet:TAVPacket;

var forwardtime:real=2;
var backwardtime:real=5;
var begintime:real;
var vbase,abase,sbase:TAVRational;
var vrate,arate,srate:TAVRational;
var vtime,atime,stime:real;
var skiptime:real;
var endtime:real;
var adjusttime:real;

var vw,vh:longint;
var newtime,oldtime:real;
var framerate:longword=60;
var fps:longint;
var showfps:boolean=false;
var showadjust:boolean=false;

var vbuflen:longint;
var vbuf:pbyte;
var vswsctx:PSwsContext;
var pv0,pvi,pvn,pvf,pvs:PVideoFRAME;
var pvb:pbitmap;

var aswrctx:PSwrContext;
var aret:longword;
var asize:longword;
var an:longword;
var wh0,whi,whn,whf,whs:PAudioFrame;

var sb0,sbi,sbn,sbf:PSubtitleFrame;

var mouse_pos:longint;
var key_posr,posr:real;
var key_shift,key_ctrl,key_alt:boolean;
var key_num:longint;
var para:ansistring;

var vposr,vlenr:real;

var hout:HWaveOut;
var fmt:TWaveFormatEx;
var binfo:bitmapinfo;

var overb:boolean;
var playb:boolean;
var pauseb:boolean;
var skipb:boolean;
var resetb:boolean;
var frameb:boolean;
var drawb:boolean;

const Volal=20;
const Vola:array[0..Volal]of word=(0,
$005B-1,$0080-1,$00B5-1,$0100-1,
$016A-1,$0200-1,$02D4-1,$0400-1,
$05A8-1,$0800-1,$0B50-1,$1000-1,
$16A1-1,$2000-1,$2D41-1,$4000-1,
$5A82-1,$8000-1,$B505-1,$10000-1);
var VolI:shortint;

const find_max=$1000;
var find_info:TSearchRec;
var find_count:longword;
var find_current:longword;
var find_result:array[0..find_max] of string;

var regdp:DWORD=1;
var regkey:HKEY;

procedure OpenKey();
begin
RegCreateKeyEx(HKEY_CURRENT_USER,
PChar('SoftWare\ax_video_player'),
0,nil,0,KEY_ALL_ACCESS,nil,regkey,nil);
end;

procedure CloseKey();
begin
RegCloseKey(regkey);
end;

function GetKeyS(kname:ansistring):ansistring;
var regtype:longword=REG_SZ;
var ca:array[0..$100-1]of byte;
var size:longword=$100;
begin
if RegQueryValueEx(regkey,PChar(kname),nil,@regtype,@ca,@size)=ERROR_SUCCESS then
  GetKeyS:=PChar(@ca)
else
  GetKeyS:='';
end;

function GetKeyI(kname:ansistring):longword;
var regtype:longword=REG_DWORD;
var ca:array[0..3] of byte;
var size:longword=4;
begin
if RegQueryValueEx(regkey,PChar(kname),nil,@regtype,@ca,@size)=ERROR_SUCCESS then
  GetKeyI:=ca[3] shl 24 or ca[2] shl 16 or ca[1] shl 8 or ca[0]
else
  GetKeyI:=0;
end;

procedure SetKeyS(kname:ansistring;s:ansistring);
begin
RegSetValueEx(regkey,PChar(kname),0,REG_SZ,PChar(s),length(PChar(s)));
end;

procedure SetKeyI(kname:ansistring;i:longword);
begin
RegSetValueEx(regkey,PChar(kname),0,REG_DWORD,@i,sizeof(DWORD));
end;

procedure find_file(s:string);
var dir:string;
begin
find_current:=0;
find_result[0]:='';
repeat
find_current:=find_current+1;
if find_current>find_count then break;
until find_result[find_current]=s;
if find_current>find_count then
  begin
  find_count:=0;
  dir:=ExtractFilePath(s);
  if findfirst(dir+'*',0,find_info)=0 then
    begin
    find_count:=find_count+1;
    find_result[find_count]:=dir+find_info.name;
    if find_result[find_count]=s then find_current:=find_count;
    while findnext(find_info)=0 do
      begin
      find_count:=find_count+1;
      find_result[find_count]:=dir+find_info.name;
      if find_result[find_count]=s then find_current:=find_count;
      end;
    end;
  end;
end;

function get_file(n:longword):string;
begin
if n<1 then n:=n+find_count;
if n>find_count then n:=n-find_count;
find_current:=n;
get_file:=find_result[find_current];
end;

function AllocVideo(w,h:longword):PVideoFRAME;
var b:PBITMAP;
begin
b:=CreateBMP(w,h,0);
AllocVideo:=Allocmem(sizeof(VideoFRAME));
AllocVideo^.frame:=b;
AllocVideo^.time:=0;
AllocVideo^.next:=nil;
end;

function NewVideo(w,h:longword):PVideoFRAME;
begin
if (pvs^.next<>nil) and (pvs^.frame^.width=w) and (pvs^.frame^.height=h) then
  begin
  NewVideo:=pvs;
  pvs:=pvs^.next;
  NewVideo^.time:=0;
  NewVideo^.next:=nil;
  end
else
  NewVideo:=AllocVideo(w,h);
end;

procedure DisposeVideo(pv:PVideoFRAME);
begin
pv^.time:=0;
pv^.next:=pvs;
pvs:=pv;
end;

procedure DisposeVideoAll();
begin
while pvn^.next<>nil do
  begin
  pvf:=pvn;
  pvn:=pvn^.next;
  DisposeVideo(pvf);
  end;
end;

Procedure FreeVideo(pv:PVideoFRAME);
begin
ReleaseBMP(pv^.frame);
//Freemem(pv^.frame);
Freemem(pv);
end;

procedure FreeVideoAll();
begin
DisposeVideoAll();
while pvs^.next<>nil do
  begin
  pvf:=pvs;
  pvs:=pvs^.next;
  FreeVideo(pvf);
  end;
end;

function AllocAudio(size:longword):PAudioFRAME;
var whb:PAudioFRAME;
begin
whb:=Allocmem(sizeof(AudioFRAME));
whb^.frame:=Allocmem(size+sizeof(WAVEHDR));
whb^.frame^.dwBufferLength:=size;
whb^.frame^.lpData:=PCHAR(whb^.frame)+sizeof(WAVEHDR);
whb^.time:=0;
whb^.next:=nil;
whb^.size:=size;
AllocAudio:=whb;
end;

function NewAudio(size:longword):PAudioFrame;
begin
if (whs^.next<>nil) and (whs^.size>=size) then
  begin
  NewAudio:=whs;
  whs:=whs^.next;
  NewAudio^.time:=0;
  NewAudio^.next:=nil;
  end
else
  NewAudio:=AllocAudio(size);
end;

procedure DisposeAudio(wh:PAudioFRAME);
begin
//wh^.time:=0;
wh^.next:=whs;
whs:=wh;
end;

procedure DisposeAudioAll();
begin
while whn^.next<>nil do
  begin
  whf:=whn;
  whn:=whn^.next;
  DisposeAudio(whf);
  end;
end;

Procedure FreeAudio(whb:PAudioFRAME);
begin
Freemem(whb^.frame);
Freemem(whb);
end;

procedure FreeAudioAll();
begin
DisposeAudioAll();
while whs^.next<>nil do
  begin
  whf:=whs;
  whs:=whs^.next;
  FreeAudio(whf);
  end;
end;

function AllocSubtitle(sf:PAVSUBTITLE):PSubtitleFRAME;
var sbt:PSubtitleFRAME;
begin
sbt:=allocmem(sizeof(SubtitleFRAME));
sbt^.frame:=allocmem(sizeof(TAVSUBTITLE));
Move(sf^,sbt^.frame^,sizeof(TAVSUBTITLE));
AllocSubtitle:=sbt;
end;

procedure FreeSubtitle(sb:PSubtitleFRAME);
begin
freemem(sb^.frame);
freemem(sb);
end;

procedure FreeSubtitleAll();
var sbt:PSubtitleFRAME;
begin
sbf:=sbi;
while sbf^.next<>nil do sbf:=sbf^.next;
repeat
sbt:=sbf^.prev;
FreeSubtitle(sbf);
sbf:=sbt;
until sbf=nil;
end;

Procedure PauseAudio(b:boolean);
begin
if b then WaveOutPause(hOut)
else WaveOutRestart(hOut);
end;

function len2sec(len:longword):real;
begin
len2sec:=len/fmt.nSamplesPerSec;
end;

function sec2len(sec:real):longword;
begin
sec2len:=trunc(sec*fmt.nSamplesPerSec);
end;

function GetAudioTime():longword;
var time:MMTIME;
begin
WaveOutGetPosition(hOut,@time,sizeof(time));
GetAudioTime:=time.ms;
end;

function GetAudioPos():longword;
begin
GetAudioPos:=GetAudioTime div fmt.nBlockAlign;
end;

function GetAudioPosr():real;
begin
GetAudioPosr:=len2sec(GetAudioPos);
end;

function GetVideoLenR():real;
begin
GetVideoLenR:=endtime;
vlenr:=GetVideoLenR;
end;

function GetVideoPosR():real;
begin
if (aindex>=0) and (whf<>whn) then
  begin
  GetVideoPosR:=GetAudioPosR;
  begintime:=gettimer-GetAudioPosR;
  end
else if vindex>=0 then
  GetVideoPosR:=gettimer-begintime
else
  GetVideoPosR:=0;
GetVideoPosR:=GetVideoPosR+skiptime;
GetVideoPosR:=GetVideoPosR+adjusttime;
if GetVideoPosR<0 then GetVideoPosR:=0;
if GetVideoPosR>GetVideoLenR then GetVideoPosR:=GetVideoLenR;
vposr:=GetVideoPosR;
end;

function GetAudioPosI():longword;
begin
GetAudioPosI:=sec2len(GetVideoPosR);
end;

function GetAudioVol():word;
var Volw:longword;
begin
WaveOutGetVolume(hOut,@Volw);
GetAudioVol:=(HI(Volw)+LO(Volw))div 2;
end;

function GetAudioVolR():real;
begin
GetAudioVolR:=GetAudioVol/$FFFF;
end;

function GetAudioVolI():shortint;
begin
GetAudioVolI:=VolI;
end;

Procedure SetVideoPosR(pos:real);
begin
skiptime:=pos;
if vindex>=0 then
  DisposeVideoAll();
if vindex>=0 then
  av_seek_frame(avfmt,vindex,trunc(skiptime/av_q2d(vbase)),AVSEEK_FLAG_BACKWARD)
else if aindex>=0 then
  av_seek_frame(avfmt,aindex,trunc(skiptime/av_q2d(abase)),AVSEEK_FLAG_BACKWARD);
atime:=skiptime;
vtime:=skiptime;
stime:=skiptime;
GetVideoLenR;
if vindex=-1 then vtime:=vlenr;
if aindex=-1 then atime:=vlenr;
if sindex=-1 then stime:=vlenr;
skipb:=true;
resetb:=true;
frameb:=false;
SetKeyI('pos',trunc(pos*1000));
end;

procedure SetAudioVol(Vol:word);
var Volw:longword;
begin
Volw:=Vol shl 16 or Vol;
WaveOutSetVolume(hOut,Volw);
end;

procedure SetAudioVolR(VolR:real);
begin
VolR:=max(0,VolR);
VolR:=min(1,VolR);
SetAudioVol(trunc(VolR*$FFFF));
end;

procedure SetAudioVolI(var VolI:shortint);
begin
VolI:=max(0,VolI);
VolI:=min(VolI,Volal);
SetAudioVol(Vola[VolI]);
SetKeyI('vol',VolI);
end;

Procedure OutAudio();
var remain:longint;
begin
while (whn^.next=nil) and playb do
  begin
  if resetb then
    begin
    WaveOutReSet(hOut);
    PauseAudio(pauseb);
    resetb:=false;
    end;
  sleep(1);
  end;
if playb then
  begin
  whn:=whn^.next;
  with whn^ do
  with frame^ do
    begin
  if(dwFlags and WHDR_PREPARED)>0 then
      WaveOutUnprepareHeader(hOut,frame,sizeof(WaveHdr));
    WaveOutPrepareHeader(hOut,whn^.frame,sizeof(WaveHdr));
    WaveOutWrite(hOut,frame,sizeof(WaveHdr));
    end;
  end;
end;

Procedure PlayAudioProc(hout:HWaveOut;msg,inst,wp,lp:longword);stdcall;
var whc:PAudioFRAME;
begin
if msg=WOM_DONE then
  if whf<>nil then
  begin
    whc:=whf;
    whf:=whf^.next;
    DisposeAudio(whc);
  end;
end;

Procedure PlayAudioThread();
begin
playb:=true;
while playb do
  OutAudio();
end;

procedure PlayNewFile(fn:string);
begin
fname:=fn;
playb:=false;
endtime:=0;
end;

function GetFullWidth():longword;
begin
GetFullWidth:=GetSystemMetrics(SM_CXFULLSCREEN)-GetBorderWidth*2;
end;

function GetFullHeight():longword;
begin
GetFullHeight:=GetSystemMetrics(SM_CYFULLSCREEN)-GetBorderHeight*2-GetBorderTitle;
end;

procedure DrawTitle();
var stitle:string;
begin
stitle:='VideoPlayer made by ax_pokl';
if playb then stitle:=ExtractFileName(fname);
if find_count>1 then stitle:=stitle+'('+i2s(find_current)+'/'+i2s(find_count)+')';
if VolI<Volal then stitle:='<'+i2s(VolI*5)+'%>'+stitle;
stitle:='['+r2s(vposr)+'/'+r2s(vlenr)+']'+stitle;
SetTitle(stitle);
end;

type bytearray=array of byte;
type realarray=array of real;

procedure GetAudioData(var wave:bytearray;pos:longword;size:longword);
var srcp,desp,szp:int64;
var posf,sizef:int64;
function max(a,b:int64):int64;
begin if a>b then max:=a else max:=b;end;
procedure MoveAudioData(wht:PAudioFRAME);
  begin
  while wht^.next<>nil do
    begin
    posf:=sec2len(wht^.time)*4;
    sizef:=wht^.size;
    srcp:=max(pos-posf,0);
    desp:=max(posf-pos,0);
    szp:=max(sizef-srcp-max(posf+sizef-pos-size,0),0);
    if szp>0 then Move((wht^.frame^.lpData+srcp)^,wave[desp],szp);
    wht:=wht^.next;
    end;
  end;
begin
pos:=pos*4;
size:=size*4;
setlength(wave,size*4);
MoveAudioData(whf);
MoveAudioData(whs);
end;

procedure GetChanData(var chan:realarray;wave:bytearray;ch:shortint);
var pi:longint=0;
var pj:longint=0;
var cb,cbi:shortint;
var max:longword=$FFFFFFFF;
var pn:longword=0;
var chi:shortint;
begin
if length(chan)<>length(wave)div 4 then
setlength(chan,length(wave)div 4);
cb:=4 div 2;
max:=1 shl (cb*8-1);
repeat
for chi:=0 to 2-1 do
  begin
  if chi=ch then
    begin
    for cbi:=0 to cb-1 do
      begin
      if cbi=0 then pn:=0;
      pn:=wave[pi] shl (cb*8) or pn;
      pn:=pn shr 8;
      pi:=pi+1;
      end;
    if cb=1 then chan[pj]:=shortint(pn)/max;
    if cb=2 then chan[pj]:=integer(pn)/max;
    if cb=4 then chan[pj]:=longint(pn)/max;
    pj:=pj+1;
    end
  else
    pi:=pi+cb;
  end;
until pi=length(wave);
end;

const ca:array[0..1]of longword=($9FFFFF,$9F0000);
const cb:array[0..4]of longword=($1FFF1F,$1F1FFF,$00FFFF,$FF00FF,$FF1F1F);

procedure DrawChanData(chan:realarray;ch:shortint);
var pi:longint;
var pos1,pos2:longword;
begin
for pi:=1 to _w-1 do
  begin
  pos1:=round((chan[pi-1]+1)/2*_h);
  pos2:=round((chan[pi-0]+1)/2*_h);
  line(pi,pos1,1,pos2-pos1,cb[ch]);
  end;
end;

var wavedata:bytearray;
var chandata:realarray;

procedure DrawAudio();
var chi:longword;
begin
if playb and not(IsIconic(_hw)) then
  begin
  if playb and not(IsIconic(_hw)) then Clear($3F0000);
  if playb and not(IsIconic(_hw)) then GetAudioData(wavedata,GetAudioPosI,_w);
  for chi:=1 downto 0 do
    begin
    if playb and not(IsIconic(_hw)) then GetChanData(chandata,wavedata,chi);
    if playb and not(IsIconic(_hw)) then DrawChanData(chandata,chi);
    end;
  if playb and not(IsIconic(_hw)) then
    Line(trunc(vposr/vlenr*_w),0,0,_h,yellow);
  end;
end;

procedure DrawSubtitleAV(avsb:PAVSubtitle);
var recti:longint;
var astr,astrln:ansistring;
var si,sn,spos:longint;
var fh:longword;
begin
with avsb^ do
  begin
  for recti:=0 to num_rects-1 do
  with avsb^.rects[recti]^ do
    begin
    if ttype=SUBTITLE_TEXT then
      astr:=text;
    if ttype=SUBTITLE_ASS then
      begin
      sn:=0;
      for si:=0 to length(ass)-1 do
        begin
        if ass[si]=',' then sn:=sn+1;
        if sn=9 then break;
        end;
      astr:=copy(ass,si+2,length(ass)-si-1);
      end;
    astr:=UTF8ToAnsi(astr);
    sn:=2;
    for si:=1 to length(astr) do
      if astr[si]='\' then sn:=sn+1;
    repeat
    spos:=system.pos('\',astr);
    if spos>0 then
      begin
      astrln:=copy(astr,1,spos-1);
      system.delete(astr,1,spos+1);
      end
    else
      begin
      astrln:=astr;
      astr:='';
      end;
    fh:=_h div 20;
    if _fh<>fh then SetFontHeight(fh);
    if not(IsIconic(_hw)) then
      DrawTextxy(astrln,
        (_w-GetStringWidth(astrln))div 2,
        (_h-GetStringHeight(astrln)*sn),white);
    sn:=sn-1;
    until spos=0;
    end;
  end;
end;

procedure DrawSubtitle();
var curtime:real;
var sbt:PSubtitleFRAME;
var avsb:PAVSubtitle;
begin
curtime:=vposr;
sbt:=sbi;
while sbt^.next<>nil do sbt:=sbt^.next;
while sbt^.prev<>nil do
  begin
  avsb:=sbt^.frame;
  if avsb<>nil then
  begin
    if (avsb^.start_display_time/1000+sbt^.time<=curtime)
    and (avsb^.end_display_time/1000+sbt^.time>=curtime) then
      begin
      DrawSubtitleAV(avsb);
      break;
      end;
    end;
  sbt:=sbt^.prev;
  end;
end;

procedure DrawVideoAV(pv:PVideoFRAME);
begin
if _w*_h>0 then
  begin
  Clear(pvb);
  if _w/_h>vw/vh then
    DrawBMP(pv^.frame,pvb,trunc((_w-_h/vh*vw)/2),0,trunc(_h/vh*vw),_h)
  else
    DrawBMP(pv^.frame,pvb,0,trunc((_h-_w/vw*vh)/2),_w,trunc(_w/vw*vh));
  end;
end;

procedure DrawVideo();
var pos,len:real;
begin
if playb and not(IsIconic(_hw)) then
  begin
  Clear(0);
  DrawBMP(pvb);
  Bar(0,0,_w,2,Yellow);
  Bar(0,0,trunc(vposr/vlenr*_w),2,Red);
  end;
end;

procedure DrawAll();
begin
if vindex>=0 then
  DrawVideo()
else if aindex>=0 then
  DrawAudio();
if sindex>=0 then
  DrawSubtitle();
fps:=getfps;
showfps:=framerate<>fps;
if showfps and not(IsIconic(_hw)) then drawtextlnxy(i2s(framerate)+'/'+i2s(fps),0,0,black,white);
if showadjust and not(IsIconic(_hw)) then drawtextlnxy(r2s(abs(adjusttime)),0,0,black,white);
DrawTitle();
FreshWin();
end;

procedure helpproc();
begin
  if fileexists(fdir+'videoplayer.txt') then
    WinExec(PChar('notepad.exe '+fdir+'videoplayer.txt'),SW_SHOW)
  else
    msgbox('Missing help file: '+fdir+'videoplayer.txt','Help file not found!');
end;

procedure DoActVideo();
begin
key_shift:=GetKeyState(VK_SHIFT)<0;
key_ctrl:=GetKeyState(VK_CONTROL)<0;
key_alt:=GetKeyState(VK_MENU)<0;
if iskey(187) then adjusttime:=adjusttime+0.1;
if iskey(189) then adjusttime:=adjusttime-0.1;
if (iskey(K_RIGHT) or iskey(K_LEFT)) then
  begin
  posr:=vposr;
  key_posr:=2;
  if key_ctrl then key_posr:=10;
  if key_shift then key_posr:=60;
  if iskey(K_RIGHT) then posr:=posr+key_posr;
  if iskey(K_LEFT) then posr:=posr-key_posr;
  if posr<0 then posr:=0;
  if posr>vlenr then posr:=vposr;
  SetVideoPosR(posr);
  end;
if (ismouseleft() or ismsg($200)) and (_ms.wparam=1) then
  begin
  mouse_pos:=Getmouseposx();
  if mouse_pos<0 then mouse_pos:=0;
  posr:=vlenr*(mouse_pos/_w);
  SetVideoPosR(posr);
  end;
if iskey(K_SPACE) or ismouseright() then
  begin
  pauseb:=not(pauseb);
  PauseAudio(pauseb);
  end;
if iskey() then
  begin
  key_num:=GetKey();
  if (key_num>=K_N0) and (key_num<=K_N9) then
    key_num:=key_num+K_0-K_N0;
  if (key_num>=K_0) and (key_num<=K_9) then
    begin
    if not(key_ctrl) then
      aindexi:=(key_num-K_1+MAXINDEX) mod MAXINDEX;
    if key_ctrl then
      sindexi:=(key_num-K_1+MAXINDEX) mod MAXINDEX;
    if key_shift then
    if vindexa[vindexi]>=0 then
      begin
      vindex:=vindexa[vindexi];
      SetVideoPosR(vposr);
      end;
    if not(key_ctrl) and not(key_shift) then
    if aindexa[aindexi]>=0 then
      begin
      aindex:=aindexa[aindexi];
      SetVideoPosR(vposr);
      end;
    if key_ctrl then
    if sindexa[sindexi]>=0 then
      begin
      sindex:=sindexa[sindexi];
      FreeSubtitleAll();
      sb0:=AllocSubtitle(sframe);
      sbi:=sb0;
      sbn:=sb0;
      sbf:=sb0;
      SetVideoPosR(vposr);
      end;
    end;
  end;
end;

procedure EndPlay();
begin
if playb then
  SetKeyI('pos',trunc(vposr*1000));
playb:=false;
overb:=true;
end;

procedure DoAct();
begin
if playb then
  DoActVideo();
if iskey(K_UP) or iskey(K_DOWN) or ismousewheel then
  begin
  if iskey(K_UP) or (ismousewheel and (_ms.wParam>0)) then VolI:=VolI+1;
  if iskey(K_DOWN) or (ismousewheel and (_ms.wParam<0)) then VolI:=VolI-1;
  SetAudioVolI(VolI);
  end;
if ismsg(WM_USER) then
  begin
  if _ms.lParam=0 then para:=para+chr(_ms.wParam mod $100);
  if _ms.lParam=1 then para:='';
  if _ms.lParam=2 then PlayNewFile(para);
  end;
if iskey(K_PGUP) or iskey(K_PGDN) or iskey(K_HOME) or iskey(K_END) then
  begin
  if iskey(K_PGUP) then PlayNewFile(get_file(find_current-1));
  if iskey(K_PGDN) then PlayNewFile(get_file(find_current+1));
  if iskey(K_HOME) then PlayNewFile(get_file(1));
  if iskey(K_END) then PlayNewFile(get_file(find_count));
  end;
if IsDropFile then
  PlayNewFile(GetDropFile);
if IsKey(K_F1) then
  newthread(@helpproc);
if iskey(K_F7) or iskey(K_F8) then
  begin
  if iskey(K_F7) and (framerate>10) then framerate:=framerate-((framerate-1) div 60+1);
  if iskey(K_F8) and (framerate<360) then framerate:=framerate+(framerate div 60+1);
  end;
if iskey(K_F9) then showadjust:=not(showadjust);
if iskey(K_ESC) then EndPlay();
end;

function NeedForward():real;
var atm,vtm:real;
begin
if aindex>=0 then atm:=atime else atm:=endtime;
if vindex>=0 then vtm:=vtime else vtm:=endtime;
NeedForward:=(vposr+forwardtime)-min(atm,vtm);
end;

function NeedBackward():real;
var atm,vtm:real;
begin
if aindex>=0 then atm:=atime else atm:=0;
if vindex>=0 then vtm:=vtime else vtm:=0;
NeedBackward:=(vposr+backwardtime)-max(atm,vtm);
end;

function NeedRead():boolean;
var nf,nb:boolean;
begin
NeedRead:=(NeedForward>=0) and (NeedBackward>=0);
end;

procedure DoDraw();
begin
//  if vindex>=0 then
  if (pvn^.next<>nil) and (pvn^.time<(vposr)) then
    begin
    pvf:=pvn;
    pvn:=pvn^.next;
    DrawVideoAV(pvf);
    DisposeVideo(pvf);
    end;
  newtime:=gettimer;
  if newtime>oldtime+1/framerate then
    begin
    while newtime>oldtime+1/framerate do
      oldtime:=oldtime+1/framerate;
    DrawAll();
    end;
  if frameb then sleep(1);
end;

procedure DrawThread();
begin
drawb:=false;
while playb do DoDraw();
drawb:=true;
end;

Procedure PlayVideo();
begin
avfmt:=avformat_Alloc_context;
if avformat_open_input(@avfmt,PChar(fname),nil,nil)<>0 then exit;
Clear(pvb);
Clear();
FreshWin();
avformat_find_stream_info(avfmt,nil);
//av_dump_format(avfmt,-1,PChar(fname),0);
endtime:=avfmt^.duration/AV_TIME_BASE;
vindex:=-1;
aindex:=-1;
sindex:=-1;
for vindexi:=0 to MAXINDEX-1 do vindexa[vindexi]:=-1;
for aindexi:=0 to MAXINDEX-1 do aindexa[aindexi]:=-1;
for sindexi:=0 to MAXINDEX-1 do sindexa[sindexi]:=-1;
for avindex:=0 to avfmt^.nb_streams-1 do
  begin
  if avfmt^.streams[avindex]^.codec^.codec_type=AVMEDIA_TYPE_Video then
    begin
    vindex:=avindex;
    vindexi:=(vindexi+1) mod MAXINDEX;
    vindexa[vindexi]:=vindex;
    end;
  if avfmt^.streams[avindex]^.codec^.codec_type=AVMEDIA_TYPE_Audio then
    begin
    aindex:=avindex;
    aindexi:=(aindexi+1) mod MAXINDEX;
    aindexa[aindexi]:=aindex;
    end;
  if avfmt^.streams[avindex]^.codec^.codec_type=AVMEDIA_TYPE_Subtitle then
    begin
    sindex:=avindex;
    sindexi:=(sindexi+1) mod MAXINDEX;
    sindexa[sindexi]:=sindex;
    end;
  end;
vindex:=vindexa[0];
aindex:=aindexa[0];
sindex:=sindexa[0];
atime:=0;
vtime:=0;
stime:=0;
skiptime:=0;
if vindex>=0 then
  begin
  vrate:=avfmt^.streams[vindex]^.r_frame_rate;
  vbase:=avfmt^.streams[vindex]^.time_base;
  vcodectx:=avfmt^.streams[vindex]^.codec;
  vcodec:=avcodec_find_decoder(vcodectx^.codec_id);
  avcodec_open2(vcodectx,vcodec,nil);
  vframe:=av_frame_alloc();
  vframergb:=av_frame_alloc();
  vw:=vcodectx^.width;
  vh:=vcodectx^.height;
  if not(IsZoomed(_hw)) then
    begin
    _w:=vw;
    _h:=vh;
    if _w>GetFullWidth then
      begin _h:=trunc(_h*GetFullWidth/_w);_w:=trunc(_w*GetFullWidth/_w);end;
    if _h>GetFullHeight then
      begin _w:=trunc(_w*GetFullHeight/_h);_h:=trunc(_h*GetFullHeight/_h);end;
    movewindow(_hw,
      max(0,(GetFullWidth()-_w) div 2),
      max(0,(GetFullHeight()-_h) div 2),
      _w+GetBorderWidth*2,
      _h+GetBorderHeight*2+GetBorderTitle,
      true);
    end;
  with binfo.bmiHeader do
    begin
    biBitCount:=32;
    biClrImportant:=0;
    biClrUsed:=0;
    biCompression:=BI_RGB;
    biPlanes:=1;
    biXPelsPerMeter:=0;
    biYPelsPerMeter:=0;
    biSize:=sizeof(binfo.bmiHeader);
    biWidth:=vw;
    biHeight:=vh;
    biSizeImage:=vw*vh*4;
    end;
  pvs:=AllocVideo(0,0);
  pv0:=NewVideo(vw,vh);
  pvi:=pv0;
  pvn:=pv0;
  pvf:=pv0;
  vbuflen:=avpicture_Get_size(AV_PIX_FMT_BGRA,vw,vh);
  vbuf:=av_mAlloc(vbuflen);
  avpicture_fill(PAVPicture(vframergb),vbuf,AV_PIX_FMT_BGRA,vw,vh);
  end
else
  begin
  _w:=GetScrWidth div 2;
  _h:=GetScrHeight div 4;
  movewindow(_hw,
    max(0,(GetFullWidth()-_w) div 2),
    max(0,(GetFullHeight()-_h) div 2),
    _w+GetBorderWidth*2,
    _h+GetBorderHeight*2+GetBorderTitle,
    true);
  end;
if aindex>=0 then
  begin
  arate:=avfmt^.streams[aindex]^.r_frame_rate;
  abase:=avfmt^.streams[aindex]^.time_base;
  acodectx:=avfmt^.streams[aindex]^.codec;
  acodec:=avcodec_find_decoder(acodectx^.codec_id);
  avcodec_open2(acodectx,acodec,nil);
  aframe:=av_frame_alloc();
  with fmt do
    begin
    nChannels:=2;
    wBitsPerSample:=16;
    nSamplesPerSec:=acodectx^.sample_rate;
    wFormatTag:=WAVE_FORMAT_PCM;
    nBlockAlign:=wBitsPerSample*nChannels shr 3;
    nAvgBytesPerSec:=nBlockAlign*nSamplesPerSec;
    cbSize:=0;
    end;
  whs:=AllocAudio(0);
  wh0:=NewAudio(0);
  wh0^.next:=nil;
  whi:=wh0;
  whn:=wh0;
  whf:=wh0;
  NewThread(@PlayAudioThread);
  WaveOutOpen(@hOut,WAVE_MAPPER,@fmt,DWORD(@PlayAudioProc),0,CALLBACK_FUNCTION);
  SetAudioVolI(VolI);
  end;
if sindex>=0 then
  begin
  srate:=avfmt^.streams[sindex]^.r_frame_rate;
  sbase:=avfmt^.streams[sindex]^.time_base;
  scodectx:=avfmt^.streams[sindex]^.codec;
  scodec:=avcodec_find_decoder(scodectx^.codec_id);
  avcodec_open2(scodectx,scodec,nil);
  sframe:=allocmem(sizeof(TAVSUBTITLE));
  sb0:=AllocSubtitle(sframe);
  sbi:=sb0;
  sbn:=sb0;
  sbf:=sb0;
  end;
frameb:=false;
playb:=true;
pauseb:=false;
skipb:=false;
begintime:=Gettimer;
GetVideoLenR;
if vindex=-1 then vtime:=vlenr;
if aindex=-1 then atime:=vlenr;
if sindex=-1 then stime:=vlenr;
if GetKeyS('fname')=fname then
  SetVideoPosR(GetKeyI('pos')/1000);
SetKeyS('fname',fname);
find_file(fname);
//NewThread(@DrawThread);
while playb do
  begin
  GetVideoPosR;
  if NeedRead() then
  if av_read_frame(avfmt,@packet)>=0 then
    begin
    if packet.stream_index=aindex then
      begin
      atime:=packet.dts*av_q2d(abase);
      avcodec_decode_Audio4(acodectx,aframe,@aframefinish,@packet);
      if atime>=skiptime then
      if aframefinish>0 then
        begin
        frameb:=true;
        aswrctx:=swr_Alloc_Set_opts(nil,
          av_Get_default_channel_layout(fmt.nChannels),AV_SAMPLE_FMT_S16,fmt.nSamplesPerSec,
          av_Get_default_channel_layout(aframe^.channels),TAVSampleFormat(aframe^.format),aframe^.sample_rate
          ,0,nil);
        swr_init(aswrctx);
        asize:=aframe^.nb_samples*av_Get_bytes_per_sample(AV_SAMPLE_FMT_S16)*2;
        while resetb do sleep(1);
        wh0:=NewAudio(asize);
        aret:=swr_convert(aswrctx,
          @(wh0^.frame^.lpData),asize,
          aframe^.data,aframe^.nb_samples);
        asize:=aret*av_Get_bytes_per_sample(AV_SAMPLE_FMT_S16)*2;
        wh0^.frame^.dwBufferLength:=asize;
        whi^.next:=wh0;
        whi^.time:=atime;
        whi:=wh0;
        swr_Free(@aswrctx);
        if skipb then skiptime:=atime;
        if skipb then skipb:=false;
        end;
      end;
    if packet.stream_index=vindex then
      begin
      vtime:=packet.dts*av_q2d(vbase);
      avcodec_decode_Video2(vcodectx,vframe,@vframefinish,@packet);
      if vtime>=skiptime then
      if vframefinish>0 then
        begin
        frameb:=true;
        vswsctx:=sws_GetContext(
          vframe^.width,vframe^.height,vcodectx^.pix_fmt,
          vw,vh,AV_PIX_FMT_BGRA,
          SWS_BILINEAR,nil,nil,nil);
        sws_Scale(vswsctx,
          vframe^.data,vframe^.linesize,0,vh,
          vframergb^.data,vframergb^.linesize);
        sws_FreeContext(vswsctx);
        pv0:=NewVideo(vw,vh);
        StretchDIBits(pvi^.frame^.dc,0,vh-1,vw,-vh,0,0,vw,vh,
        vframergb^.data[0],binfo,DIB_RGB_COLORS,SRCCOPY);
        pvi^.time:=vtime;
        pvi^.next:=pv0;
        pvi:=pvi^.next;
        if skipb then begintime:=gettimer;
        if skipb then skiptime:=vtime;
        if skipb then skipb:=false;
        end;
      end;
    if packet.stream_index=sindex then
      begin
      stime:=packet.dts*av_q2d(sbase);
      avcodec_decode_subtitle2(scodectx,sframe,@sframefinish,@packet);
      if stime>=skiptime then
      if sframefinish>0 then
        begin
        while (sbi^.next<>nil) and (sbi^.time<stime) do sbi:=sbi^.next;
        while (sbi^.prev<>nil) and (sbi^.time>stime) do sbi:=sbi^.prev;
        sbn:=sbi^.next;
        if (sbi^.time<stime) then
          if sbn=nil then
            begin
            sb0:=AllocSubtitle(sframe);
            sb0^.time:=stime;
            sb0^.prev:=sbi;
            sb0^.next:=sbi^.next;
            sbi^.next:=sb0;
            end
          else if sbn^.time>stime then
            begin
            sb0:=AllocSubtitle(sframe);
            sb0^.time:=stime;
            sb0^.prev:=sbi;
            sb0^.next:=sbi^.next;
            sbn^.prev:=sb0;
            sbi^.next:=sb0;
            end;
        end;
      end;
    av_Free_packet(@packet);
    end
  else
    begin
    frameb:=true;
    skipb:=false;
    end;
  if vposr>=vlenr then
    begin
    frameb:=true;
    skipb:=false;
    end;
  if Not(IsWin()) then EndPlay();
  while IsNextMsg() do DoAct();
  DoDraw();
  if frameb then sleep(1);
  end;
//while not(drawb) do delay(1);
if vindex>=0 then
  begin
  av_Free(vbuf);
  av_Free(vframe);
  av_Free(vframergb);
  avcodec_close(vcodectx);
  FreeVideoAll();
  FreeVideo(pvn);
  FreeVideo(pvs);
  end;
if aindex>=0 then
  begin
  WaveOutReSet(hOut);
  WaveOutClose(hOut);
  av_Free(aframe);
  avcodec_close(acodectx);
  FreeAudioAll();
  FreeAudio(whn);
  FreeAudio(whs);
  end;
if sindex>=0 then
  begin
  FreeSubtitleAll();
  freemem(sframe);
  end;
avformat_close_input(@avfmt);
end;

procedure User();
var hwm:longword;
var i:longword;
begin
hwm:=FindWindow('DisplayClass',nil);
if ParamCount>=1 then
  para:=ParamStr(1)
else
  para:='';
if hwm<>0 then
  if para<>'' then
    begin
    SendMessage(hwm,WM_USER,0,1);
    for i:=1 to length(para) do
    begin
      SendMessage(hwm,WM_USER,longword(ord(para[i])),0);
      end;
    SendMessage(hwm,WM_USER,0,2);
    halt;
    end;
end;

procedure Init();
begin
OpenKey();
VolI:=GetKeyI('vol');
fname:=GetKeyS('fname');
if VolI=0 then VolI:=16;
if ParamCount>=1 then fname:=ParamStr(1);
fdir:=ParamStr(0);
repeat
if length(fdir)>0 then delete(fdir,length(fdir),1);
until (length(fdir)<=1) or (fdir[length(fdir)]='\');
createwin();
SetDrawProcedure(@DrawVideo);
pvb:=CreateBMP(GetScrWidth,GetScrHeight);
setfontname('Consolas');
//_wc.HIcon:=LoadImage(0,'videoplayer.ico',IMAGE_ICON,0,0,LR_LOADFROMFILE);
_wc.HIcon:=LoadIcon(MainInstance,'MAINICON');
sendmessage(_hw,WM_SETICON,ICON_BIG,longint(_wc.HIcon));
oldtime:=gettimer;
av_register_all();
end;

procedure Main();
begin
overb:=false;
while not(overb) do
  begin
  aindex:=-1;
  vindex:=-1;
  if FileExists(fname) then PlayVideo();
  if Not(IsWin()) then EndPlay();
  while IsNextMsg() do DoAct();
  DrawTitle();
  sleep(1);
  end;
CloseKey();
end;

begin
User();
Init();
Main();
end.
